/*
==================================================
-----------------------------------------------
 Description   : CPP
 Creation Date : 2003.07.12
 Last Revision : 2003.07.12
 File          : Pick
 Coded By      : Vincenzo Caldarulo
 Modified by   : Vincenzo Caldarulo
 Copyright (c) 2000, V&D Software
-----------------------------------------------
===================================================
*/



#include "Pick.h"


Pick	PickObj;

//==============================
//--------------------------
//
//--------------------------
Pick::Pick()
{
	N_Mesh = 0;
	Xsize = 0;
	Ysize = 0;
	ArePixelSize = 0;
	InitIsOK = false;

}

void Pick::Pick_Init(int _Xsize,int _Ysize)
{
	//===>
	Xsize = _Xsize;
	Ysize = _Ysize;
	ArePixelSize = Xsize*Ysize;
	//
	B_Pixel = new UC_RGB[ArePixelSize];
	if(!B_Pixel){ 
		char strMessage[256] = {0};
		sprintf(strMessage, "Non  stato possibile creare un buffer Pick :%d", ArePixelSize);
		MessageBox(NULL, strMessage, "Error", MB_OK);
		return;
	}else{
		memset(B_Pixel,0,sizeof(UC_RGB)*ArePixelSize);
	}
	//===>
	InitIsOK = true;
}
//==============================
//--------------------------
//
//--------------------------
void Pick::Pick_AddMesh( GroupEntity *_Ext_Mesh )
{
	//===>
	if(!InitIsOK){ char strMessage[256] = {0};	sprintf(strMessage, "Inizializzazione del PICK non eseguita");	MessageBox(NULL, strMessage, "Error", MB_OK);	return;	}
	//===>
	Ext_Mesh[N_Mesh] = _Ext_Mesh;
	N_Mesh++;
}
//==============================
//--------------------------
//
//--------------------------
UC_RGB ConvLongToRGB(unsigned long Val)
{
	UC_RGB Color;
	Color.R = unsigned char((Val & MASK_BIT8 )>>0 );	
	Color.G = unsigned char((Val & MASK_BIT16)>>8 );
	Color.B = unsigned char((Val & MASK_BIT24)>>16);
	return Color;
}
//==============================
//--------------------------
//
//--------------------------
long ConvRGBToLong(UC_RGB Color)
{
	long R,G,B;
	//===>
	R = long(Color.R) * (1);
	G = long(Color.G) * (1<<8 );
	B = long(Color.B) * (1<<16);
	//===>
	return long(R + G + B);
}
//==============================
//--------------------------
//
//--------------------------
void Pick::Pick_Build()
{
	//===>
	if(!InitIsOK){ char strMessage[256] = {0};	sprintf(strMessage, "Inizializzazione del PICK non eseguita");	MessageBox(NULL, strMessage, "Error", MB_OK);	return;	}
	//===>
	long c0,c1,c2,c3;

	UC_RGB  C		= ConvLongToRGB(537);
	long Val	= ConvRGBToLong(C);

	long DBP=0;
	//=======================================
	//------------------------------------
	// Creazione dei buffer Oggetto Pick
	//------------------------------------
	//=======================================
	//
	//===>
	// Creazione delle Mesh
	Mesh = new Pick_Mesh[N_Mesh];
	if (Mesh==NULL){ char strMessage[256] = {0};	sprintf(strMessage, "Non  stato possibile creare un buffer Mesh di:%d", N_Mesh);	MessageBox(NULL, strMessage, "Error", MB_OK);	return;	}
	//===>
	// Creazione delle MeshCall
	MeshCall = new Pick_Call_Mesh[N_Mesh];
	if (MeshCall==NULL){ char strMessage[256] = {0};	sprintf(strMessage, "Non  stato possibile creare un buffer MeshCall di:%d", N_Mesh);	MessageBox(NULL, strMessage, "Error", MB_OK);	return;	}
	//===>
	for( c0=0; c0<N_Mesh; c0++){
		//===>
		// Creazione delle superfici
		Mesh[c0].N_Surface	= Ext_Mesh[c0]->N_Elemnts;
		Mesh[c0].Surface		= new Pick_Surface[Mesh[c0].N_Surface];
		if (Mesh[c0].Surface==NULL){ char strMessage[256] = {0};	sprintf(strMessage, "Non  stato possibile creare un buffer Surface di:%d / %d", N_Mesh, Mesh[c0].N_Surface);	MessageBox(NULL, strMessage, "Error", MB_OK);	return;	}
		//===>
		// Creazione delle superfici
		MeshCall[c0].N_Surface	= Ext_Mesh[c0]->N_Elemnts;
		MeshCall[c0].Surface		= new Pick_Call_Surface[MeshCall[c0].N_Surface];
		if (MeshCall[c0].Surface==NULL){ char strMessage[256] = {0};	sprintf(strMessage, "Non  stato possibile creare un buffer SurfaceCall di:%d / %d", N_Mesh, MeshCall[c0].N_Surface);	MessageBox(NULL, strMessage, "Error", MB_OK);	return;	}
		//===>
		for( c1=0; c1<Mesh[c0].N_Surface; c1++){
			if (Ext_Mesh[c0]->GEntity[c1].GEntity->N_Triangle>0){
				//===>
				// Creazione dei Triangoli
				Mesh[c0].Surface[c1].N_Triangles	= Ext_Mesh[c0]->GEntity[c1].GEntity->N_Triangle;
				Mesh[c0].Surface[c1].Triangles		= new Pick_Triangle[Mesh[c0].Surface[c1].N_Triangles];
				if (Mesh[c0].Surface[c1].Triangles==NULL){ char strMessage[256] = {0};	sprintf(strMessage, "Non  stato possibile creare un buffer Triangoli di:%d / %d / %d", N_Mesh, Mesh[c0].N_Surface, Mesh[c0].Surface[c1].N_Triangles );	MessageBox(NULL, strMessage, "Error", MB_OK);	return;	}
				//===>
				DBP += Ext_Mesh[c0]->GEntity[c1].GEntity->N_Triangle;
			}
		}
		//===>
	}
	//=======================================
	//------------------------------------
	// Init Database Pick
	//------------------------------------
	//=======================================
	//
	PickDB = new Pick_DB [DBP];
	if (PickDB==NULL ){ char strMessage[256] = {0};	sprintf(strMessage, "Non  stato possibile creare Database Pick:%d", N_Mesh);	MessageBox(NULL, strMessage, "Error", MB_OK);		InitIsOK = false; return;	}
	//=======================================
	//------------------------------------
	// Init dei buffer Oggetto Pick
	//------------------------------------
	//=======================================
	//
	//===>
	UC_RGB Color;
	long NTria=0;
	//===>

	for( c0=0; c0<N_Mesh; c0++){
		//===>
		MeshCall[c0]._GEntity = Ext_Mesh[c0];
		//===>
		for( c1=0; c1<Mesh[c0].N_Surface; c1++){
			//===>
			MeshCall[c0].Surface[c1]._Entity = Ext_Mesh[c0]->GEntity[c1].GEntity;
			//===>
			for( c2=0; c2<Mesh[c0].Surface[c1].N_Triangles; c2++){
				//===>
				PickDB[NTria].Mesh = c0;
				PickDB[NTria].Surf = c1;
				PickDB[NTria].Tria = c2;
				NTria++;
				//===>
				for( c3=0; c3<3; c3++){
					//===>
					// Settiamo le coordinate
					Mesh[c0].Surface[c1].Triangles[c2].Triangle[c3].vx = Ext_Mesh[c0]->GEntity[c1].GEntity->ListTriangle[c2].triangle[c3].vx;
					Mesh[c0].Surface[c1].Triangles[c2].Triangle[c3].vy = Ext_Mesh[c0]->GEntity[c1].GEntity->ListTriangle[c2].triangle[c3].vy;
					Mesh[c0].Surface[c1].Triangles[c2].Triangle[c3].vz = Ext_Mesh[c0]->GEntity[c1].GEntity->ListTriangle[c2].triangle[c3].vz;
					//===>
					//
					Color = ConvLongToRGB(NTria);
					//Color.R = 0.5f;	Color.G = 0;	Color.B = 0;
					Mesh[c0].Surface[c1].Triangles[c2].Triangle[c3].vcR0 = Color.R;
					Mesh[c0].Surface[c1].Triangles[c2].Triangle[c3].vcG0 = Color.G;
					Mesh[c0].Surface[c1].Triangles[c2].Triangle[c3].vcB0 = Color.B;

				}
				//===>
			}
			//===>
		}
		//===>
	}
	//=======================================
	//------------------------------------
	// Call List Mesh
	//------------------------------------
	//=======================================
	//
	//===>
	for( c0=0; c0<N_Mesh; c0++){
		//===>
		MeshCall[c0].Call_Mesh = glGenLists(1);
		glNewList(MeshCall[c0].Call_Mesh,GL_COMPILE);
		//===>
		for( c1=0; c1<Mesh[c0].N_Surface; c1++){
			//===>
			for( c2=0; c2<Mesh[c0].Surface[c1].N_Triangles; c2++){
				//===>
				glBegin(GL_TRIANGLES);
				//===>
				for( c3=0; c3<3; c3++){
					//===>
					//
					glColor3ub(	Mesh[c0].Surface[c1].Triangles[c2].Triangle[c3].vcR0,
											Mesh[c0].Surface[c1].Triangles[c2].Triangle[c3].vcG0,
											Mesh[c0].Surface[c1].Triangles[c2].Triangle[c3].vcB0);
					//===>
					//
					glVertex3f(	Mesh[c0].Surface[c1].Triangles[c2].Triangle[c3].vx,
											Mesh[c0].Surface[c1].Triangles[c2].Triangle[c3].vy,
											Mesh[c0].Surface[c1].Triangles[c2].Triangle[c3].vz);
					//===>
				}
				//===>
				glEnd();
				//===>
			}
			//===>
		}
		//===>
		glEndList();
		//===>
	}

}


//==============================
//--------------------------
//
//--------------------------
Pick_DB Pick::Pick_GetMesh( int X, int Y)
{	
	Pick_DB PObj={-1,-1,-1};
	//===>
	if(!InitIsOK){ char strMessage[256] = {0};	sprintf(strMessage, "Inizializzazione del PICK non eseguita");	MessageBox(NULL, strMessage, "Error", MB_OK);	return PObj;	}
	//===>
	Scene.SetView( X, Y, Xsize, Ysize);
	//===>
	long _Mesh = 0;
	int Pick_X, Pick_Y, Pick_ID;
	//RGB Col;
	Pick_X = ( Xsize >> 1);	Pick_Y = ( Ysize >> 1);
	Pick_ID = (Pick_Y*Xsize)+Pick_X;
	//===>
	glDepthFunc ( GL_LESS );
	glMatrixMode( GL_MODELVIEW );
	glShadeModel( GL_SMOOTH );
	glDisable(GL_LIGHTING); // Disabilita lilluminazione
	//===>
	for(long c0=0; c0<N_Mesh; c0++){
		//===============================================
		//-------------------------------------------
		// 
		glLoadIdentity();	// Resetta la ViewPort
		Camera.OnCamera();// Setta la Camera
		//===>
		glRotatef( MeshCall[c0].Surface[0]._Entity->Rot.x, 1.0f, 0.0f, 0.0f);
		glRotatef( MeshCall[c0].Surface[0]._Entity->Rot.y, 0.0f, 1.0f, 0.0f);
		glRotatef( MeshCall[c0].Surface[0]._Entity->Rot.z, 0.0f, 0.0f, 1.0f);
		//===>
		glTranslatef( MeshCall[c0].Surface[0]._Entity->Pos.x, 
									MeshCall[c0].Surface[0]._Entity->Pos.y, 
									MeshCall[c0].Surface[0]._Entity->Pos.z );
		//===>
		glScalef( MeshCall[c0].Surface[0]._Entity->Scl.x, 
							MeshCall[c0].Surface[0]._Entity->Scl.y, 
							MeshCall[c0].Surface[0]._Entity->Scl.z);
		//===>
		glCallList(MeshCall[c0].Call_Mesh);
	}
	//===>
	// Capture Immage to get obj
	glPixelStorei(GL_PACK_ALIGNMENT,1);
	//glReadPixels( X, Y, Xsize, Ysize, GL_RGB,GL_UNSIGNED_BYTE,B_Pixel);
	glReadPixels( X, Y, Xsize, Ysize, GL_RGB,GL_UNSIGNED_BYTE,B_Pixel);

	if(InputCL.Trigger(Key_F9))
	{
		int aaa=0;
	}
	//===>
	_Mesh = ConvRGBToLong(B_Pixel[Pick_ID])-1;
	//===>
/*
	//===>
	// Draw pixel
	B_Pixel[Pick_ID].R = 255;
	B_Pixel[Pick_ID].G = 255;
	B_Pixel[Pick_ID].B = 255;
	glPixelStorei(GL_UNPACK_ALIGNMENT,1);
	glDrawPixels(Xsize, Ysize,GL_RGB, GL_UNSIGNED_BYTE,B_Pixel);
//*/

	return PickDB[_Mesh];
	//===>
}


float PinkPlaneDistance(Vect3D Normal, Vect3D Point)
{	
	float distance = 0;									// This variable holds the distance from the plane tot he origin

	// Use the plane equation to find the distance (Ax + By + Cz + D = 0)  We want to find D.
	// So, we come up with D = -(Ax + By + Cz)
														// Basically, the negated dot product of the normal of the plane and the point. (More about the dot product in another tutorial)
	distance = - ((Normal.x * Point.x) + (Normal.y * Point.y) + (Normal.z * Point.z));

	return distance;									// Return the distance
}

Vect3D PinkIntersectionPoint(Vect3D vNormal, Vect3D vLPoint0, Vect3D vLPoint1, double distance)
{
	Vect3D vPoint, vLineDir;					// Variables to hold the point and the line's direction
	double Numerator = 0.0, Denominator = 0.0, dist = 0.0;

	// 1)  First we need to get the vector of our line, Then normalize it so it's a length of 1
	vLineDir = vLPoint1 - vLPoint0;		// Get the Vector of the line
	vLineDir = vLineDir.Normalize();	// Normalize the lines vector


	// 2) Use the plane equation (distance = Ax + By + Cz + D) to find the 
	// distance from one of our points to the plane.
	Numerator = -(vNormal.x * vLPoint0.x +						// Use the plane equation with the normal and the line
								vNormal.y * vLPoint0.y +
								vNormal.z * vLPoint0.z + distance);

	// 3) If we take the dot product between our line vector and the normal of the polygon,
	Denominator = Dot(vNormal, vLineDir);		// Get the dot product of the line's vector and the normal of the plane
				  
	// Since we are using division, we need to make sure we don't get a divide by zero error
	// If we do get a 0, that means that there are INFINATE points because the the line is
	// on the plane (the normal is perpendicular to the line - (Normal.Vector = 0)).  
	// In this case, we should just return any point on the line.

	if( Denominator == 0.0){			// Check so we don't divide by zero
		return vLPoint0;						// Return an arbitrary point on the line
	}

	dist = Numerator / Denominator;				// Divide to get the multiplying (percentage) factor
	
	// Now, like we said above, we times the dist by the vector, then add our arbitrary point.
	vPoint.x = (float)(vLPoint0.x + (vLineDir.x * dist));
	vPoint.y = (float)(vLPoint0.y + (vLineDir.y * dist));
	vPoint.z = (float)(vLPoint0.z + (vLineDir.z * dist));

	return vPoint;								// Return the intersection point
}

Pick_Coord Pick::Pick_GetCoordinate2(Pick_DB _DBP)
{
	Pick_Coord Point; 
	EN_Triangle_VNT1* _Tria = &GObject[_DBP.Mesh].GEntity[_DBP.Surf].GEntity->ListTriangle[_DBP.Tria];
	Vect3D LPoint2;
	LPoint2 = Camera.Pos+Camera.Lock;
	Point.Dist	= PinkPlaneDistance(_Tria->Normal,Camera.Pos);
	Point.Coord = PinkIntersectionPoint(_Tria->Normal,Camera.Pos,LPoint2,Point.Dist);
	return Point;
}
//==============================
//--------------------------
//
//--------------------------
Pick_Coord Pick::Pick_GetCoordinate(Pick_DB _DBP)
{
	Pick_Coord Point;
	Point.Coord.Set(0);
	Point.Dist = 0;
	//===>
	if(!InitIsOK){ char strMessage[256] = {0};	sprintf(strMessage, "Inizializzazione del PICK non eseguita");	MessageBox(NULL, strMessage, "Error", MB_OK);	return Point;	}
	//===>
	// Termini noti
	Vect3D P0,P1,P2,P3,DirCam;
	float l,m,n;
	// fattori Equazione piano
	float a,b,c,d;
	//
	float k;
	//===>
	// Assegnazione termini noti
	//
	P0.x	= Camera.Pos.x;		P0.y	= Camera.Pos.y;		P0.z	= Camera.Pos.z;
	l	= Camera.Vector.x;		m	= Camera.Vector.y;		n	= Camera.Vector.z;
	//
	EN_Vertex_VNT1 *ID_Tria = MeshCall[_DBP.Mesh].Surface[_DBP.Surf]._Entity->ListTriangle[_DBP.Tria].triangle;
	P1.x = ID_Tria[0].vx;		P1.y = ID_Tria[0].vy;		P1.z = ID_Tria[0].vz;
	P2.x = ID_Tria[1].vx;		P2.y = ID_Tria[1].vy;		P2.z = ID_Tria[1].vz;
	P3.x = ID_Tria[2].vx;		P3.y = ID_Tria[2].vy;		P3.z = ID_Tria[2].vz;
	//===>
	// a = (y2-y1)*(z3-z1) - (z2-z1)*(y3-y1)
	// b = (z2-z1)*(x3-x1) - (x2-x1)*(z3-z1);
	// c = (x2-x1)*(y3-y1) - (y2-y1)*(x3-x1);

	// d =((z2-z1)*(y3-y1) - (y2-y1)*(z3-z1))*x1 + 
	//		((x2-x1)*(z3-z1) - (z2-z1)*(x3-x1))*y1 + 
	//		((y2-y1)*(x3-x1) - (x2-x1)*(y3-y1))*z1;
	//===>
	a = ((P2.y-P1.y)*(P3.z-P1.z)) - ((P2.z-P1.z)*(P3.y-P1.y));
	b = ((P2.z-P1.z)*(P3.x-P1.x)) - ((P2.x-P1.x)*(P3.z-P1.z));
	c = ((P2.x-P1.x)*(P3.y-P1.y)) - ((P2.y-P1.y)*(P3.x-P1.x));

	d =	((P2.z-P1.z)*(P3.y-P1.y) - (P2.y-P1.y)*(P3.z-P1.z))*P1.x + 
			((P2.x-P1.x)*(P3.z-P1.z) - (P2.z-P1.z)*(P3.x-P1.x))*P1.y + 
			((P2.y-P1.y)*(P3.x-P1.x) - (P2.x-P1.x)*(P3.y-P1.y))*P1.z;
/*
	a =  (P1.y*P2.z)+(P2.y*P3.z)+(P1.z*P3.y)-(P3.y*P2.z)-(P3.z*P1.y)-(P2.y*P1.z);
	b = -(P1.x*P2.z)-(P1.z*P3.x)-(P2.x*P3.z)+(P3.x*P2.z)+(P1.x*P3.z)+(P2.x*P1.z);
	c =  (P1.x*P2.y)+(P1.y*P3.x)+(P2.x*P3.y)-(P2.y*P3.x)-(P1.x*P3.y)-(P2.x*P1.y);
	d = -(P1.x*P2.y*P3.z)-(P1.y*P2.z*P3.x)-(P2.x*P3.y*P1.z)+(P3.x*P2.y*P1.z)+(P3.y*P2.z*P1.x)+(P2.x*P1.y*P3.z);
*/
	// ax+by+cz+d=0   -=>  a*x+b*y+c*z+d=0

	//===>
	//k =   (( a*x0 + b*y0 + c*z0 + d ) 
	//		- ---------------------------
	//					( a*l + b*m + c*n));
	
	k = -(( a*P0.x + b*P0.y + c*P0.z + d ) / ( a*l + b*m + c*n));

	//===>
	Point.Coord.x = P0.x + (l*k);
	Point.Coord.y = P0.y + (m*k);
	Point.Coord.z = P0.z + (n*k);
	Point.Dist = ( a*P0.x + b*P0.y + c*P0.z + d )/sqrt(a*a+b*b+c*c);
	//===>
	return Point;
}

